Imports System
Imports System.Text
Imports System.io
Imports System.Diagnostics
Imports System.Collections


Public Class NotUniqueException
   Inherits ArgumentException
   Protected _Object As Object
   Protected _PropName As String
   Protected _Count As Integer

   Public ReadOnly Property TypeName() As String
      Get
         Return _Object.GetType.Name
      End Get
   End Property
   Public ReadOnly Property PropName() As String
      Get
         Return _PropName
      End Get
   End Property
   Public ReadOnly Property Count() As Integer
      Get
         Return _Count
      End Get
   End Property

   Protected Shared Function CreateMessage( _
           ByVal ObjectArg As Object, _
           ByVal PropNameArg As String, _
           ByVal CountArg As Integer) As String
      With New IO.StringWriter
         .Write("Bei Suche nach {0} in {1} wurden {2} Ergebnis(se) gefunden. ", _
             PropNameArg, ObjectArg.GetType.Name, CountArg)
         .WriteLine("Zulssig ist nur 1 Ergebnis")
         Return .ToString
      End With
   End Function

   Public Sub New( _
           ByVal ParameterName As String, _
           ByVal LookIn As Object, _
           ByVal LookForWhat As String, _
           ByVal CountArg As Integer)
      MyBase.New(CreateMessage(LookIn, LookForWhat, CountArg), ParameterName)
      _Object = LookIn
      _PropName = LookForWhat
      _Count = CountArg
   End Sub

End Class 'NotUniqueException

Public Class LongMsgException
   Inherits Exception
   Public Sub New(ByVal ParamArray Args() As Object)
      MyBase.new(CreateMessage(Args))
   End Sub
   Public Sub New(ByVal InnerEx As Exception, ByVal ParamArray Args() As Object)
      MyBase.new(CreateMessage(Args), InnerEx)
   End Sub
   Private Shared Function CreateMessage(ByVal Args() As Object) As String
      Dim Messages(Args.Length - 1) As String
      For I As Integer = 0 To Args.Length - 1
         Messages(I) = Args(I).ToString
      Next
      Return StringEx.Concat(Messages)
   End Function
End Class
