Imports System
Imports System.IO
Imports System.Collections
Imports System.Text.RegularExpressions

Namespace System.Text

   Public Class StringEx

      Private Shared _LineFeedRegex As New Regex( _
              "(?<=(^|[^\\](\\\\)*))\\n", _
              System.Text.RegularExpressions.RegexOptions.Compiled)   '_LineFeedRegex matcht "\n" nur,
      '!                                                wenn eine ungerade Anzahl "\" vor dem "n" sind

      Public Shared Function Concat(ByVal ParamArray sArgs As String()) As String
         'verkettet sArgs, wandelt \n in vbNewline. Bsp:
         ''Debug.WriteLine(StringEx.Concat( _
         ''    "Die Datei\n", "XY.txt", "\nkonnte nicht gefunden werden"))
         Return _LineFeedRegex.Replace(String.Concat(sArgs), vbNewLine)
      End Function

      Public Shared Function Format( _
              ByVal sFormat As String, ByVal ParamArray Args As Object()) As String
         'gibt Args formatiert zurck, interpretiert "\n" als vbNewline. Bsp:
         ''Debug.WriteLine(StringEx.Format( _
         ''    "Die Datei\n{0}\nkonnte nicht gefunden werden", "XY.txt"))
         Return String.Format(_LineFeedRegex.Replace(sFormat, vbNewLine), Args)
      End Function

      Public Shared Function CountSubStrings( _
              ByVal S As String, _
              ByVal sMatch As String, _
              Optional ByVal Options As RegexOptions = RegexOptions.IgnoreCase) As Integer
         Return Regex.Matches(S, sMatch.Replace("\", "\\"), Options).Count
      End Function

      Public Shared Function CountChars(ByVal S As String, ByVal cMatch As Char) As Integer
         Dim I As Integer = S.IndexOf(cMatch)
         While I >= 0
            CountChars += 1
            I = S.IndexOf(cMatch, I + 1)
         End While
      End Function

      Public Shared Function LeftCut(ByVal S$, ByVal sMatch$) As String
         Dim I% = S.IndexOf(sMatch)
         If I < 0 Then Return S
         Return S.Substring(0, I)
      End Function

      Public Shared Function LastLeftCut( _
              ByVal S$, ByVal sMatch$, Optional ByVal FailReturn As String = "") As String
         Dim I% = S.LastIndexOf(sMatch)
         If I < 0 Then Return FailReturn
         Return S.Substring(0, I)
      End Function
      Public Shared Function LastRightCut( _
              ByVal S$, ByVal sMatch$, Optional ByVal FailReturn As String = "") As String
         Dim I% = S.LastIndexOf(sMatch)
         If I < 0 Then Return FailReturn
         Return S.Substring(I + sMatch.Length)
      End Function

      Public Shared Function RightCut(ByVal S$, ByVal sMatch$) As String
         Return S.Substring(S.IndexOf(sMatch) + sMatch.Length)
      End Function

      Public Shared Function ReplaceLast( _
              ByVal Text As String, ByVal OldTxt As String, ByVal NewTxt As String) As String
         With Text
            Dim I As Integer = .LastIndexOf(OldTxt)
            If I < 0 Then Return Text
            Return .Substring(0, I) & .Substring(I).Replace(OldTxt, NewTxt)
         End With
      End Function

      Public Class SeparatorCountComparer
         'zum Vergleich der Anzahl von StringSegmenten, etwa in Dateinamen
         Implements IComparer(Of String)
         Protected _Separator As String
         Public Sub New(ByVal Separator As String)
            _Separator = Separator
         End Sub
         Public Overridable Function Compare(ByVal x As String, ByVal y As String) As Integer _
         Implements System.Collections.Generic.IComparer(Of String).Compare
            Return CountSubStrings(x, _Separator) - CountSubStrings(y, _Separator)
         End Function
      End Class 'SeparatorCountComparer

   End Class 'StringEx
End Namespace
