Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.io
Imports System.ComponentModel
Namespace System.Windows.Forms

   <DesignerCategory("code")>
   Public Class CaptionedSplitContainer
      'OnPaint schreibt die Caption auf den Splitterbalken (Horizontale Orientierung)
      Inherits SplitContainer
      Private _CaptionFormat As New StringFormat
      Private _FontHeight As Integer

      Public Sub New()
         MyBase.New()
         MyBase.Orientation = Windows.Forms.Orientation.Horizontal
         MyBase.SplitterWidth = 20
      End Sub

      <Browsable(True)> Public Shadows Property Text() As String
         Get
            Return MyBase.Text
         End Get
         Set(ByVal value As String)
            MyBase.Text = value
         End Set
      End Property

      <Browsable(True)> Public Property TextAlign() As StringAlignment
         Get
            Return _CaptionFormat.Alignment
         End Get
         Set(ByVal value As StringAlignment)
            _CaptionFormat.Alignment = value
         End Set
      End Property

      Protected Overrides Sub OnFontChanged(ByVal e As System.EventArgs)
         _FontHeight = 0
         MyBase.OnFontChanged(e)
      End Sub

      Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
         If MyBase.Orientation = Windows.Forms.Orientation.Horizontal Then
            Dim X, Y As Integer
            Dim ClientRect As Rectangle = MyBase.ClientRectangle
            With e.ClipRectangle
               If .Height < MyBase.SplitterWidth Then
                  'Clipping zu klein fr Drawstring
                  'vollstndiges Neuzeichnen erzwingen
                  MyBase.Invalidate()
                  Return
               End If
            End With
            MyBase.OnPaint(e)
            If _FontHeight = 0 Then
               _FontHeight = CInt(e.Graphics.MeasureString( _
                   "H", _
                   MyBase.Font, _
                   PointF.Empty, _
                   _CaptionFormat).Height)
            End If
            Y = MyBase.SplitterDistance + (MyBase.SplitterWidth - _FontHeight) \ 2
            Select Case Me.TextAlign
               Case StringAlignment.Near
                  X = 0
               Case StringAlignment.Center
                  X = ClientRect.Width \ 2
               Case StringAlignment.Far
                  X = ClientRect.Width
            End Select
            e.Graphics.DrawString(MyBase.Text, MyBase.Font, Brushes.Black, X, Y, _CaptionFormat)
         Else
            MyBase.OnPaint(e)
         End If
      End Sub

      Protected Overrides Sub OnSizeChanged(ByVal e As System.EventArgs)
         Static OldWidth As Integer = -1
         MyBase.OnSizeChanged(e)
         With MyBase.ClientRectangle
            If .Width <> OldWidth Then
               OldWidth = .Width
               'vollstndiges Neuzeichnen erzwingen
               MyBase.Invalidate()
            End If
         End With
      End Sub

   End Class
End Namespace
