﻿Imports System
Imports System.Text
Imports System.Collections
Namespace System.Windows.Forms

   Friend Class ObsoleteStringList
#Region "Description"
#If NoCompile Then
   'vereinfacht den Aufbau komplexer Strings, bes. wenn durch Komma getrennte Listen generiert
   '! werden müssen. Bsp:
   With New StringList
       For I As Integer = 1 To 10
           .Add(I.ToString)
       Next
       Debug.WriteLine("Zahlen von 1 - 10: " & .ToString(", "))
   End With

   'Bsp. für strukturierten Aufbau von Regular Expressions:
      Dim SL As New StringList
      SL.Added = "(?<Quote>"                  'Name
      SL.Ind.Added = "(^|"")"                 'Anfang oder "
      SL.Added = ")"
      SL.Added = "[^""]*"                     'alles außer "
      SL.Added = "(?<Quote2-Quote>"           'aufzeichne von Quote bis einschl. Quote2
      SL.Ind.Added = "($|"")"                 'Ende oder "
      SL.Added = ")"
      Dim Rgx As New System.Text.RegularExpressions.Regex( _
         SL.ToString(vbNewLine), RegexOptions.Compiled)
   'Identisch mit:
      Dim Rgx As New System.Text.RegularExpressions.Regex( _
         "(?<Quote>(^|""))[^""]*(?<Quote2-Quote>($|""))", RegexOptions.Compiled)

#End If 'NoCompile
#End Region 'Description
      Inherits ArrayList
      Public Sub New(ByVal ParamArray Args() As String)
         MyBase.New(Args)
      End Sub
      Public Sub AddFormat(ByVal Format As String, ByVal ParamArray Args() As Object)
         MyBase.Add(StringEx.Format(Format, Args))
      End Sub
      Public Shared Function Create(ByVal ParamArray Args() As String) As ObsoleteStringList
         Return New ObsoleteStringList(Args)
      End Function
      Public Shadows Function ToString(Optional ByVal Separator As String = " ") As String
         Return String.Join(Separator, DirectCast(MyBase.ToArray(GetType(String)), String()))
      End Function
      Public Shadows Function Concat() As String
         Return String.Concat(DirectCast(MyBase.ToArray(GetType(String)), String()))
      End Function
      Public Shadows Function Add(ByVal ParamArray Args() As String) As ObsoleteStringList
         If Args.Length = 0 Then Return Me
         MyBase.Add(String.Concat(Args))
         Return Me
      End Function
      Public Shadows Function Ind() As ObsoleteStringList
         'Nur ein Platzhalter, um logische Einrückungen (Indention) sichtbar zu machen
         Return Me
      End Function
      Public WriteOnly Property Added() As String
         'Add-Variante als Property - läßt den Text optisch deutlicher hervortreten
         Set(ByVal value As String)
            Add(value)
         End Set
      End Property

   End Class

End Namespace
