Public Class GridViewColumnCollectionWrapper
   'tut so wie eine GridViewColumnCollection, ist aber keine eigenstndige Auflistung, sondern lenkt
   '! nur alle Zugriffe auf die Columns-Property eines Dummi-DataGridViews um
   Implements IList

   Protected _DummiColumns As DataGridViewColumnCollection
   Protected _Grid As DataGridView
   Public Sub New(ByVal Grid As DataGridView)
      _Grid = Grid
      _DummiColumns = Grid.Columns
   End Sub

   Public Sub CopyTo(ByVal array As System.Array, ByVal index As Integer) _
         Implements System.Collections.ICollection.CopyTo
      _DummiColumns.CopyTo(array, index)
   End Sub

   Public ReadOnly Property Count() As Integer Implements System.Collections.ICollection.Count
      Get
         Return _DummiColumns.Count
      End Get
   End Property

   Public ReadOnly Property IsSynchronized() As Boolean _
         Implements System.Collections.ICollection.IsSynchronized
      Get
         Return _DummiColumns.IsSynchronized
      End Get
   End Property

   Public ReadOnly Property SyncRoot() As Object _
         Implements System.Collections.ICollection.SyncRoot
      Get
         Return _DummiColumns.SyncRoot
      End Get
   End Property

   Public Function GetEnumerator() As System.Collections.IEnumerator _
         Implements System.Collections.IEnumerable.GetEnumerator
      Return _DummiColumns.GetEnumerator
   End Function

   Public Overridable Sub LastAutoFill()
      _Grid.SuspendLayout()
      For I As Integer = 0 To Me.Count - 2
         DirectCast(Me.Item(I), DataGridViewColumn).AutoSizeMode = _
            DataGridViewAutoSizeColumnMode.NotSet
      Next
      DirectCast(Me.Item(Count - 1), DataGridViewColumn).AutoSizeMode = _
         DataGridViewAutoSizeColumnMode.Fill
      _Grid.ResumeLayout()
   End Sub

   Public Overridable Function Add(ByVal value As Object) As Integer _
         Implements System.Collections.IList.Add
      Add = _DummiColumns.Add(DirectCast(value, DataGridViewColumn))
      'LastAutoFill()
   End Function

   Public Sub Clear() Implements System.Collections.IList.Clear
      _DummiColumns.Clear()
   End Sub

   Public Function Contains(ByVal value As Object) As Boolean _
         Implements System.Collections.IList.Contains
      Return _DummiColumns.Contains(DirectCast(value, DataGridViewColumn))
   End Function

   Public Function IndexOf(ByVal value As Object) As Integer _
         Implements System.Collections.IList.IndexOf
      Return _DummiColumns.IndexOf(DirectCast(value, DataGridViewColumn))
   End Function

   Public Sub Insert(ByVal index As Integer, ByVal value As Object) _
         Implements System.Collections.IList.Insert
      _DummiColumns.Insert(index, DirectCast(value, DataGridViewColumn))
   End Sub

   Public ReadOnly Property IsFixedSize() As Boolean _
         Implements System.Collections.IList.IsFixedSize
      Get
         Return False
      End Get
   End Property

   Public ReadOnly Property IsReadOnly() As Boolean _
         Implements System.Collections.IList.IsReadOnly
      Get
         Return _DummiColumns.IsReadOnly
      End Get
   End Property

   Default Public Property Item(ByVal index As Integer) As Object _
         Implements System.Collections.IList.Item
      Get
         Return _DummiColumns.Item(index)
      End Get
      Set(ByVal value As Object)

      End Set
   End Property

   Public Sub Remove(ByVal value As Object) Implements System.Collections.IList.Remove
      _DummiColumns.Remove(DirectCast(value, DataGridViewColumn))
      'LastAutoFill()
   End Sub

   Public Sub RemoveAt(ByVal index As Integer) Implements System.Collections.IList.RemoveAt
      _DummiColumns.RemoveAt(index)
      'LastAutoFill()
   End Sub
End Class