Public Class clsTableFormatter
   Private _CutFromLeft As Boolean
   Private _FillChar As Char = " "c
   Private _CharWidths As Dictionary(Of Char, Integer)
   Private _Columns() As Integer
   Private _Alignment As StringAlignment 'Functionalitt noch nicht implementiert

   Public Sub New(ByVal CharWidths As Dictionary(Of Char, Integer))
      _CharWidths = CharWidths
   End Sub

   Public Function ColumnWidths(ByVal Value As Integer()) As clsTableFormatter
      _Columns = Value
      Return Me
   End Function

   Public Function Alignment(ByVal Value As StringAlignment) As clsTableFormatter
      _Alignment = Value
      Return Me
   End Function

   Public Function ToLine(ByVal Texts() As String) As String
      'fge mehrere Strings zu einer Tabellenzeile zusammen
      Dim Ubound As Integer = Math.Min(Texts.Length, _Columns.Length) - 1
      Dim Temp(Ubound) As String
      Dim ColumnPadding As Integer = _CharWidths("."c) * 3
      Dim Width As Integer = 0
      For iText As Integer = 0 To Ubound
         Dim MaxChars, RequiredWidth As Integer
         MaxChars = 0
         RequiredWidth = _Columns(iText) - Width
         RequiredWidth -= ColumnPadding
         Width = 0
         For MaxChars = 0 To Texts(iText).Length - 1
            Width += _CharWidths(Texts(iText).Chars(MaxChars))
            If Width > RequiredWidth Then
               Width -= _CharWidths(Texts(iText).Chars(MaxChars))
               Exit For
            End If
         Next
         Temp(iText) = Texts(iText).Substring(0, MaxChars)
         If MaxChars < Texts(iText).Length Then
            Temp(iText) &= "..."
            Width += ColumnPadding
         End If
         If iText < Ubound Then 'letzte Spalte nicht mit Spaces auffllen
            RequiredWidth += ColumnPadding
            Dim iFill As Integer = (RequiredWidth - Width) \ _CharWidths(_FillChar)
            If iFill > 0 Then
               Temp(iText) &= Strings.StrDup(iFill, _FillChar)
               Width += iFill * _CharWidths(_FillChar)
            End If
            Width -= RequiredWidth 'Der berstand wird von der nchsten Spalte abgezogen
         End If

      Next
      Return String.Concat(Temp)
   End Function
End Class
