Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel
Imports System.Text
Imports System.io
Imports System.Diagnostics
Imports System.Collections
Imports System.Text.RegularExpressions
Imports System.Drawing
Imports System.Xml
Imports System.Xml.Serialization

Public Class uclTreeListview
   Implements ISupportInitialize

   Private _Columns As TLVColumnCollection
   Private _TableFormatter As clsTableFormatter
   Private _RedrawID As Integer = Integer.MinValue + 1 'Zur Geschwindigkeitsoptimierung: nderungen an den Spalten erzeugen eine neue RedrawID. Nur der Basis-Text derjenigen TLVNodes wird neu gesetzt, deren RedrawID von dieser hier abweicht.

   Public Sub New()
      InitializeComponent()
      'If MyDesignMode Then Return
      With Me.HeaderGrid
         .Height = .ColumnHeadersHeight
      End With
      _Columns = New TLVColumnCollection(Me.HeaderGrid)
   End Sub
   Public Sub BeginUpdate()
      Me.TreeView.BeginUpdate()
   End Sub
   Public Sub EndUpdate()
      Me.TreeView.EndUpdate()
   End Sub
   Public ReadOnly Property Nodes() As TreeNodeCollection
      Get
         Return Me.TreeView.Nodes
      End Get
   End Property

   '<Editor("System.Windows.Forms.Design.ImageIndexEditor, System.Design, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a", GetType(System.Drawing.Design.UITypeEditor)), RefreshProperties(RefreshProperties.Repaint), RelatedImageList("ImageList"), Localizable(True), TypeConverter(GetType(ImageKeyConverter)), DefaultValue(""), Category("Verhalten")> _
   <Editor("System.Windows.Forms.Design.ImageIndexEditor", GetType(System.Drawing.Design.UITypeEditor)), RefreshProperties(RefreshProperties.Repaint), RelatedImageList("ImageList"), Localizable(True), TypeConverter(GetType(ImageKeyConverter)), DefaultValue(""), Category("Verhalten")> _
   Public Property SelectedImageKey() As String
      Get
         Return Me.TreeView.SelectedImageKey
      End Get
      Set(ByVal value As String)
         Me.TreeView.SelectedImageKey = value
      End Set
   End Property

   <Editor("System.Windows.Forms.Design.ImageIndexEditor", GetType(System.Drawing.Design.UITypeEditor)), RefreshProperties(RefreshProperties.Repaint), RelatedImageList("ImageList"), Localizable(True), TypeConverter(GetType(ImageKeyConverter)), DefaultValue(""), Category("Verhalten")> _
   Public Property ImageKey() As String
      Get
         Return Me.TreeView.ImageKey
      End Get
      Set(ByVal value As String)
         Me.TreeView.ImageKey = value
      End Set
   End Property

   <Browsable(True)> _
   Public Property ImageList() As ImageList
      Get
         Return Me.TreeView.ImageList
      End Get
      Set(ByVal value As ImageList)
         Me.TreeView.ImageList = value
      End Set
   End Property

   Private Sub HeaderGrid_ColumnHeadersHeightChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles HeaderGrid.ColumnHeadersHeightChanged
      With Me.HeaderGrid
         .Height = .ColumnHeadersHeight
      End With
   End Sub

   <DesignerSerializationVisibility(DesignerSerializationVisibility.Content), _
   BrowsableAttribute(True), Category("Verhalten")> _
   Public ReadOnly Property Columns() As TLVColumnCollection
      Get
         Return _Columns
      End Get
   End Property

   <Browsable(True)> _
   Public Property HeadersHeight() As Integer
      Get
         Return Me.HeaderGrid.ColumnHeadersHeight
      End Get
      Set(ByVal value As Integer)
         Me.HeaderGrid.ColumnHeadersHeight = value
      End Set
   End Property


   Private Sub SetLeftOffset(ByVal Value As Integer)
      If Value < 4 Then Value = 4
      If Me.HeaderGrid.RowHeadersWidth = Value Then Exit Sub
      Me.HeaderGrid.RowHeadersWidth = Value
      'Invalidate()
   End Sub

   Private Sub InvalidateNodeTexts()
      'RedrawID kann niemals Integer.MinValue werden, der Initialisierungs-RedrawID-Wert neuer TLVNodes
      If _RedrawID = Integer.MaxValue Then _RedrawID = Integer.MinValue
      _RedrawID += 1
      Me.TreeView.Invalidate()
   End Sub

   Public Event AfterSelect As TreeViewEventHandler
   Private Sub TreeView_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView.AfterSelect
      RaiseEvent AfterSelect(Me, e)
   End Sub


   Private Sub TreeView_PaintEx(ByVal sender As Object, ByVal e As EventArgs) Handles TreeView.PaintEx
      'per Subclassing erzeugtes Paint-Event
      'In allen sichtbaren Nodes den Anzeigetext mit dem Inhalt-Text abgleichen.
      Dim ND As TreeNode = Me.TreeView.TopNode
      If ND Is Nothing Then Exit Sub
      Me.SetLeftOffset(ND.Bounds.Left)
      Do
         DirectCast(ND, clsTreeListViewNode).UpdateBaseText(_RedrawID, _TableFormatter)
         ND = ND.NextVisibleNode
      Loop Until ND Is Nothing
      'UpdateBaseText(_RedrawID)
   End Sub


   Private Sub HeaderGrid_ColumnWidthChanged(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewColumnEventArgs)
      If e.Column.Index < _Columns.Count - 1 Then InvalidateNodeTexts()
      _TableFormatter.ColumnWidths(_Columns.Widths)
   End Sub

   Public Sub BeginInit() Implements System.ComponentModel.ISupportInitialize.BeginInit

   End Sub

   Public Sub EndInit() Implements System.ComponentModel.ISupportInitialize.EndInit
      'If MyDesignMode() Then Return
      With Me.Columns
         If .Count = 0 Then Return
         .Item(.Count - 1).AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
      End With
      With Me.HeaderGrid
         .Height = .ColumnHeadersHeight
      End With
      Me.Columns.LastAutoFill()
      If MyDesignMode() Then Return
      'die Breiten von 255 Zeichen bestimmen
      Dim CharWidths As New Dictionary(Of Char, Integer)
      Me.TreeView.BeginUpdate()
      Dim DummiNode As TreeNode = Me.TreeView.Nodes.Add("")
      Dim Width0 As Integer = DummiNode.Bounds.Width
      Width0 = DummiNode.Bounds.Width 'erst beim 2. Zugriff liefert DummiNode.Bounds den richtigen Wert
      For I As Integer = 1 To 255
         Dim C As Char = Convert.ToChar(I)
         DummiNode.Text = C
         CharWidths.Add(C, DummiNode.Bounds.Width - Width0)
      Next
      DummiNode.Remove()
      Me.TreeView.EndUpdate()
      _TableFormatter = New clsTableFormatter(CharWidths)
      _TableFormatter.ColumnWidths(_Columns.Widths)
      AddHandler HeaderGrid.ColumnWidthChanged, AddressOf HeaderGrid_ColumnWidthChanged
   End Sub

End Class
